import ac
import acsys
import math
import time
import threading
import configparser
import os
import platform
import sys
import json
import random

if platform.architecture()[0] == "64bit":
	sysdir = os.path.dirname(__file__)+'/stdlib64'
else:
	sysdir = os.path.dirname(__file__)+'/stdlib'

sys.path.insert(0, sysdir)
os.environ['PATH'] = os.environ['PATH'] + ";."

import keyboard
from random import random
from array import *

# Sound Mixer Import
import pygame.mixer
import pygame.mixer_music
import pygame
from pygame.locals import *
pygame.init()

pygame.mixer.pre_init(44100, 16, 2, 512)   # pre init 44.1khz, 16bit, mono, buffer(KB)
pygame.mixer.init(44100)                       # init mixer

sound_turbo = pygame.mixer.Sound("apps/python/Ecu_tuner/data/sounds/turbo.wav")
sound_bang = pygame.mixer.Sound("apps/python/Ecu_tuner/data/sounds/antilag exhaust1.wav")
sound_bang2 = pygame.mixer.Sound("apps/python/Ecu_tuner/data/sounds/antilag exhaust2a.wav")
sound_antilag_rev = pygame.mixer.Sound("apps/python/Ecu_tuner/data/sounds/antilag rev1.wav")

ar = []
ar_list = []
ar_perc = []
afr_perc = []
afr_base = []
afr_base_list = []
afr = []
afr_list = []
ign_base = []
ign_base_list = []
ign = []
ign_list = []
ecu_codes_list = [0, 0, 0, 0, 0, 0, 0]

car_name = ""
ext_ecu_light = ""
ext_intensity_info = ""
ext_intensity_info2 = ""
ext_intensity_info3 = ""
ext_intensity_info4 = ""
ext_intensity_info5 = ""


rpms = 0
rpms1 = 0
car_name1 = 1 #_ecu car? 1-yes 0-no
rpms_car_factor = 1 #rpms factor for wg springs
count1=0
count2=0
l_lapcount=0
lapcount=0
button1=8000 #rpm limiter value
fuelcut=1.45
almost_limiter = 0
boost_set = 0.518
boost_max = 0.038
boost_timer = 40
boost_timer_springs = 0
boost_set_springs = 0
throttle_perc = 10
throttle_perc_1 = 10
throttle_perc_a = 0
throttle_perc_1s = ""
throttle_perc_2s = ""
throttle_perc_2 = 0
throttle_perc_x10 = 10
throttle_perc_x1 = 0
throttle_set_1 = 0
throttle_set_a = 0
throttle_set_1s = ""
throttle_set_2s = ""
throttle_set_2 = 0
throttle_set = 5
throttle_set_ign = 0
throttle_set_rest = 0
throttle_set_ra = 0
throttle_set_antilag = 0
throttle_set_total = 0
throttle_switch = 0 #switching between rpm limiter and fuelcut
spring = 1 #wastegate spring selection...1-7psi, 2-15psi
ecu_light = 0
mbc_pos = 0
mbc_factor = 0
mbc_on = 0
boost_map_visible = 1
boost_table_pos = 0
boost_table_pos1 = 0 #value at specific boost_table_pos
boost_table_pos1a = 0 #same, but from array
boost_table_pos1_old = 0
boost_map_value_perc = 0
boost_map_value_perc0 = 0
boost_map_value_perc1 = 0
boost_map_value_perc0a = 0
boost_map_value_perc0b = 0
boost_map_value_perc1a = 0
boost_map_value_perc1b = 0
boost_map_value_perc_old = 0
switch1 = 0
switch2 = 0
switch3 = 0
switch4 = 0
boost_set_pwm = 0
afr_map_visible = 1
afr_info1 = 14.7
afr_base_table_pos = 0
afr_table_pos = 0 #value at specific afr_base_table_pos
afr_table_pos1a = 0 #same, but from array
afr_table_pos1 = 0
afr_table_pos1_display = 0
afr_table_pos1_old = 0
afr_table_pos1a_old = 0
afr_map_value_perc = 0
afr_map_value_perc0 = 0
afr_map_value_perc1 = 0
afr_map_value_perc0a = 0
afr_map_value_perc0b = 0
afr_map_value_perc1a = 0
afr_map_value_perc1b = 0
ign_map_visible = 1
ign_info1 = 0
ign_base_table_pos = 0
ign_table_pos = 0 #value at specific ign_base_table_pos
ign_table_pos1a = 0 #same, but from array
ign_table_pos1 = 0
ign_table_pos1_diff = 0
ign_table_pos1_diff_forboost = 0
ign_table_pos1_display = 0
ign_table_pos1_old = 0
ign_table_pos1a_old = 0
ign_map_value_perc = 0
ign_map_value_perc0 = 0
ign_map_value_perc1 = 0
ign_map_value_perc0a = 0
ign_map_value_perc0b = 0
ign_map_value_perc1a = 0
ign_map_value_perc1b = 0
boost_total = 0 #vacuum+boost_info
vacuum = 0 #from -0.8bar to 0
brake_info1 = 0
clutch_info1 = 0
smoother_sum = 14.7
smoother_sum_ign = 10
smoother_sum_ign_diff = 10
smoother_sum_boost = 0
counter_ign = 0
counter_afr = 0
counter_pwm = 0
gas_correct = 0
gas_cut_factor = 0
gas_cut_factor2 = 0
key_pressed = 0
throttle_cut = 0
ecu_codes_total = 0
ecu_code_reading = 0
ecu_code_value = 0
ecu_reading = 0
ecu_info_visible = 1
shifting = 0
gear_info_old = 1
duty_cycle = 0
injectors = 1
inj_factor = 220
inj_afr = 0
inj_size_afr = 1
lc_map_visible = 1
lc_btn_on = 0
lc2_btn_on = 0
lc_rpms = 4000
lc_speed = 50
lc_timing = 30
lc_afr = 20
lc_boost_oscilation = 0
rolling_antilag = 0
antilag = 0
boost_set_antilag = 0
boost_timer_antilag = 0
speed_info = 0
boost_volume = 0
banner_img = 0
a = 10
b = 10
smoke_intensity = 1
smoke_spread = 0
flame_intensity = 1
boost_set_lua = 0

trigger1 = 0
trigger2 = 0
trigger3 = 0
trigger4 = 0
trigger5 = 0
time0 = 0
time1 = 0
time2 = 0
time3 = 0
time4 = 0
time5 = 0
time6 = 0
time7 = 0
time8 = 0
time9 = 0
time10 = 0
time11 = 0
time12 = 0
time13 = 0
time14 = 0
time15 = 0
time16 = 0
time17 = 0
time18 = 0
time19 = 0
time20 = 0
time21 = 0
time22 = 0
time23 = 0
time24 = 0
time25 = 0
time26 = 0
time27 = 0
time28 = 0
time29 = 0

def acMain(ac_version):
   global l_lapcount, appWindow, btnCarCommon, count1, count2, btnCarCommon2, rpm_limiter, rpm_limiter_value, throttle, version, version2, btn_lc, btn_lc_active, btn_lc2_active, lc_info_rpm
   global boost, btnCarCommon3, btnCarCommon4, btnCarCommon5, btnCarCommon6, boost_limiter, boost_limiter_value, btn_fuelcut1, btn_fuelcut2
   global fuelcut_value, banner, ecu_logo, mbc_logo, mbc_info, btn_boost_map, btn_boost_map, btn_afr_map, btn_ign_map, btn_boost_map_value, boost_map_value, afr_map_value, afr_base_value, afr_info, ign_map_value, ign_base_value, ign_info
   global btn_x, btn_y, brake_info, btn_x2, btn_y2, btn_x3, btn_y3, btn_ecu_codes, ecu_info, brake_info1, inj_dc_info, car_name, car_name1
   global btn_lc_rpm1, btn_lc_rpm2, lc_rpms, lc_info_speed, lc_speed, btn_lc_speed1, btn_lc_speed2, lc_timing, btn_lc_timing1, btn_lc_timing2, lc_info_timing, lc_afr, lc_info_afr, btn_lc_afr1, btn_lc_afr2
   global sound_turbo, sound_bang, sound_bang2, sound_antilag_rev
   global boost_map, afr_map, ign_map, lc_map
   global ext_intensity_info, ext_intensity_info2, ext_intensity_info3, ext_intensity_info4, ext_intensity_info5


   appWindow = ac.newApp("  ")
   ac.setSize(appWindow, 380, 600)

   banner = ac.addLabel(appWindow, "");
   ac.setPosition(banner, 0, 0)
   ac.setSize(banner, 380, 80)

   ac.setBackgroundOpacity(banner,0)

   version = ac.addLabel(appWindow, "Free version");
   ac.setPosition(version, 260, 85)
   ac.setFontSize(version, 10)
   ac.setFontColor(version, 0, 1, 0, 0)
   
   version2 = ac.addLabel(appWindow, "Download Pro version here: \n www.patreon.com/user?u=84541959");
   ac.setPosition(version2, 290, 95)
   ac.setFontSize(version2, 10)
   ac.setFontAlignment(version2, "center")
   ac.setFontColor(version2, 0, 0, 0, 0)

   ext_intensity_info = ac.addLabel(appWindow, "INTENSITY =");
   ac.setVisible(ext_intensity_info, 0) #hide 
   
   btnCarCommon = ac.addButton(appWindow, "-")
   ac.setPosition(btnCarCommon, 10, 130)
   ac.setSize(btnCarCommon, 100, 20)
   ac.addOnClickedListener(btnCarCommon, remRPM)

   btnCarCommon2 = ac.addButton(appWindow, "+")
   ac.setPosition(btnCarCommon2, 150, 130)
   ac.setSize(btnCarCommon2, 100, 20)
   ac.addOnClickedListener(btnCarCommon2, addRPM)

   rpm_limiter = ac.addLabel(appWindow, "RPM Limiter");
   ac.setPosition(rpm_limiter, 100, 100)
   ac.setFontSize(rpm_limiter, 10)

   rpm_limiter_value = ac.addLabel(appWindow, "RPM Limiter");
   ac.setPosition(rpm_limiter_value, 100, 115)
   ac.setFontSize(rpm_limiter_value, 10)

   btnCarCommon3 = ac.addButton(appWindow, "7 psi")
   ac.setPosition(btnCarCommon3, 10, 270)
   ac.setSize(btnCarCommon3, 100, 20)
   ac.setBackgroundOpacity(btnCarCommon3, 1)
   ac.addOnClickedListener(btnCarCommon3, remBoost)

   btnCarCommon4 = ac.addButton(appWindow, "15psi")
   ac.setPosition(btnCarCommon4, 150, 270)
   ac.setSize(btnCarCommon4, 100, 20)
   ac.setBackgroundOpacity(btnCarCommon4, 0)
   ac.addOnClickedListener(btnCarCommon4, addBoost)

   boost_limiter = ac.addLabel(appWindow, "Fuel Cut");
   ac.setPosition(boost_limiter, 100, 155)
   ac.setFontSize(boost_limiter, 10)

   btn_fuelcut1 = ac.addButton(appWindow, "-")
   ac.setPosition(btn_fuelcut1, 10, 185)
   ac.setSize(btn_fuelcut1, 100, 20)
   ac.addOnClickedListener(btn_fuelcut1, rem_fuelcut)

   btn_fuelcut2 = ac.addButton(appWindow, "+")
   ac.setPosition(btn_fuelcut2, 150, 185)
   ac.setSize(btn_fuelcut2, 100, 20)
   ac.addOnClickedListener(btn_fuelcut2, add_fuelcut)

   fuelcut_value = ac.addLabel(appWindow, "set Boost:");
   ac.setPosition(fuelcut_value, 100, 170)
   ac.setFontSize(fuelcut_value, 10)

   springs = ac.addLabel(appWindow, "Wastegate Spring:");
   ac.setPosition(springs, 100, 255)
   ac.setFontSize(springs, 10)

   inj_info = ac.addLabel(appWindow, "Injectors:");
   ac.setPosition(inj_info, 100, 210)
   ac.setFontSize(inj_info, 10)

   btnCarCommon5 = ac.addButton(appWindow, "stock")
   ac.setPosition(btnCarCommon5, 10, 230)
   ac.setSize(btnCarCommon5, 100, 20)
   ac.setBackgroundOpacity(btnCarCommon5, 1)
   ac.addOnClickedListener(btnCarCommon5, inj1)

   btnCarCommon6 = ac.addButton(appWindow, "650cc")
   ac.setPosition(btnCarCommon6, 150, 230)
   ac.setSize(btnCarCommon6, 100, 20)
   ac.setBackgroundOpacity(btnCarCommon6, 0)
   ac.addOnClickedListener(btnCarCommon6, inj2)
   
   mbc_title = ac.addLabel(appWindow, "Manual Boost Controller:");
   ac.setPosition(mbc_title, 100, 310)
   ac.setFontSize(mbc_title, 10)

   mbc_title = ac.addLabel(appWindow, "Info:");
   ac.setPosition(mbc_title, 20, 380)

   ac.log("Hello, Assetto Corsa application world!")
   ac.console("Hello, Assetto Corsa console!")

   l_lapcount = ac.addLabel(appWindow, "RPM: 0");
   ac.setPosition(l_lapcount, 20, 400)

   boost_limiter_value = ac.addLabel(appWindow, "Boost Limiter");
   ac.setPosition(boost_limiter_value, 20, 420)
   ac.setVisible(boost_limiter_value, 0) #hide

   boost = ac.addLabel(appWindow, "Boost: 0");
   ac.setPosition(boost, 20, 440)

   throttle = ac.addLabel(appWindow, "RPM Limiter");
   ac.setPosition(throttle, 20, 460)
   ac.setVisible(throttle, 1) #hide

   mbc_info = ac.addLabel(appWindow, "MBC: 0");
   ac.setPosition(mbc_info, 20, 480)
   
   afr_info = ac.addLabel(appWindow, "AFR: 0");
   ac.setPosition(afr_info, 20, 500)   
   
   brake_info = ac.addLabel(appWindow, "Brake: 0");
   ac.setPosition(brake_info, 20, 520)     
   ac.setVisible(brake_info, 1)

   ign_info = ac.addLabel(appWindow, "IGN: 0");
   ac.setPosition(ign_info, 20, 540) 

   inj_dc_info = ac.addLabel(appWindow, "Inj DC: 0");
   ac.setPosition(inj_dc_info, 20, 560) 

   ecu_logo = ac.addLabel(appWindow, "");
   ac.setPosition(ecu_logo, 270, 430)
   ac.setSize(ecu_logo, 50, 35)
   ac.setBackgroundOpacity(ecu_logo,0)

   mbc_logo = ac.addLabel(appWindow, "");
   ac.setPosition(mbc_logo, 100, 330)
   ac.setSize(mbc_logo, 70, 66)
   ac.setBackgroundOpacity(mbc_logo,0)
   ac.addOnClickedListener(mbc_logo, add_mbcvalue)

   boost_map = ac.newApp("Boost control Solenoid PWM map")
   ac.setSize(boost_map, 650, 500)
   ac.setVisible(boost_map, 0)
   ac.setBackgroundTexture(boost_map,"apps/python/Ecu_tuner/data/tables/boost table.png")
   ac.setBackgroundOpacity(boost_map, 0.9)

   btn_boost_map = ac.addButton(appWindow, "boost map")
   ac.setPosition(btn_boost_map, 240, 300)
   ac.setSize(btn_boost_map, 100, 20)
   ac.addOnClickedListener(btn_boost_map, boost_table)
   ac.setBackgroundOpacity(btn_boost_map, 0)
   
   btn_ecu_codes = ac.addButton(appWindow, "Reading Ecu Error codes")
   ac.setPosition(btn_ecu_codes, 200, 480)
   ac.setSize(btn_ecu_codes, 170, 20)
   ac.setBackgroundOpacity(btn_ecu_codes, 0)
   ac.addOnClickedListener(btn_ecu_codes, reading_ecu_codes)  
   
   btn_ecu_codes_clear = ac.addButton(appWindow, "Clear codes")
   ac.setPosition(btn_ecu_codes_clear, 230, 510)
   ac.setSize(btn_ecu_codes_clear, 120, 20)
   ac.addOnClickedListener(btn_ecu_codes_clear, clearing_ecu_codes)
   
   btn_ecu_codes_info = ac.addButton(appWindow, "ECU Codes info")
   ac.setPosition(btn_ecu_codes_info, 230, 540)
   ac.setSize(btn_ecu_codes_info, 120, 20)
   ac.addOnClickedListener(btn_ecu_codes_info, ecu_codes_info)
   ac.setBackgroundOpacity(btn_ecu_codes_info, 0)
   
   ecu_info = ac.newApp("")
   ac.setSize(ecu_info, 424, 600)
   ac.setVisible(ecu_info, 0)
   ac.setBackgroundTexture(ecu_info,"apps/python/Ecu_tuner/data/ecu codes/ecu3.png")
   ac.setBackgroundOpacity(ecu_info, 0.1)
   
   
   #boost table
   for a in range(0, 64):
      boost_map_value = ac.addSpinner(boost_map, "");
      ac.setSize(boost_map_value, 60 , 20)
      b = int(a / 8)
      ac.setPosition(boost_map_value, 50 + (a * 70) - (b * 560) , 400 - (50 * b))
      ar_list.append(boost_map_value)
      ac.setBackgroundOpacity(boost_map_value, 0)

   afr_map = ac.newApp("Injection open time correction map")
   ac.setSize(afr_map, 650, 500)
   ac.setVisible(afr_map, 0)
   ac.setBackgroundTexture(afr_map,"apps/python/Ecu_tuner/data/tables/afr table.png")
   ac.setBackgroundOpacity(afr_map, 0.9)

   btn_afr_map = ac.addButton(appWindow, "afr map")
   ac.setPosition(btn_afr_map, 240, 330)
   ac.setSize(btn_afr_map, 100, 20)
   ac.addOnClickedListener(btn_afr_map, afr_table)
   ac.setBackgroundOpacity(btn_afr_map, 0)      
   
   ign_map = ac.newApp("Ignition timing map")
   ac.setSize(ign_map, 650, 500)
   ac.setVisible(ign_map, 0)
   ac.setBackgroundTexture(ign_map,"apps/python/Ecu_tuner/data/tables/afr table.png")
   ac.setBackgroundOpacity(ign_map, 0.9)

   btn_ign_map = ac.addButton(appWindow, "timing map")
   ac.setPosition(btn_ign_map, 240, 360)
   ac.setSize(btn_ign_map, 100, 20)
   ac.addOnClickedListener(btn_ign_map, ign_table)
   ac.setBackgroundOpacity(btn_ign_map, 0)       

   #x,y lines for realtime boost table position
   btn_x = ac.addButton(boost_map, "")
   ac.setPosition(btn_x, 0, 130)
   ac.setSize(btn_x, 650, 1)

   btn_y = ac.addButton(boost_map, "")
   ac.setPosition(btn_y, 130, 0)
   ac.setSize(btn_y, 1, 500)

   #x,y lines for realtime afr table position
   btn_x2 = ac.addButton(afr_map, "")
   ac.setPosition(btn_x2, 0, 130)
   ac.setSize(btn_x2, 650, 1)

   btn_y2 = ac.addButton(afr_map, "")
   ac.setPosition(btn_y2, 130, 0)
   ac.setSize(btn_y2, 1, 500)   
   
   #x,y lines for realtime ignition table position
   btn_x3 = ac.addButton(ign_map, "")
   ac.setPosition(btn_x3, 0, 130)
   ac.setSize(btn_x3, 650, 1)

   btn_y3 = ac.addButton(ign_map, "")
   ac.setPosition(btn_y3, 130, 0)
   ac.setSize(btn_y3, 1, 500) 

   #afr table
   for a in range(0, 64):
      afr_map_value = ac.addSpinner(afr_map, "");
      ac.setSize(afr_map_value, 60 , 20)
      b = int(a/8)
      ac.setPosition(afr_map_value, 50 + (a*70) - (b*560) , 400 - (50 * b))
      ac.setRange(afr_map_value, -50, 50)
      afr_list.append(afr_map_value)      
      ac.setBackgroundOpacity(afr_map_value, 0)
 
   #afr base table
   for a in range(0, 64):
      afr_base_value = ac.addSpinner(afr_map, "");
      afr_base_list.append(afr_base_value)
      ac.setVisible(afr_base_value, 0)      
      
   #ignition table
   for a in range(0, 64):
      ign_map_value = ac.addSpinner(ign_map, "");
      ac.setSize(ign_map_value, 60 , 20)
      b = int(a/8)
      ac.setPosition(ign_map_value, 50 + (a*70) - (b*560) , 400 - (50 * b))
      ac.setRange(ign_map_value, -20, 20)
      ign_list.append(ign_map_value)      
      ac.setBackgroundOpacity(ign_map_value, 0)
 
   #ignition base table
   for a in range(0, 64):
      ign_base_value = ac.addSpinner(ign_map, "");
      ign_base_list.append(ign_base_value)
      ac.setVisible(ign_base_value, 0)      


   btn_save_boost_map = ac.addButton(appWindow, "save map")
   ac.setPosition(btn_save_boost_map, 290, 390)
   ac.setSize(btn_save_boost_map, 80, 20)
   ac.addOnClickedListener(btn_save_boost_map, save_boost_table)

   btn_load_boost_map = ac.addButton(appWindow, "load map")
   ac.setPosition(btn_load_boost_map, 200, 390)
   ac.setSize(btn_load_boost_map, 80, 20)
   ac.addOnClickedListener(btn_load_boost_map, load_boost_table)

   #launch control
   btn_lc = ac.addButton(appWindow, "Launch Control \n Antilag \n Rolling Antilag")
   ac.setPosition(btn_lc, 290, 140)
   ac.setSize(btn_lc, 80, 40)
   ac.setFontSize(btn_lc, 10)
   ac.setBackgroundOpacity(btn_lc, 0)
   ac.addOnClickedListener(btn_lc, lc_table)
   
   lc_map = ac.newApp("Antilag, Launch control and Rolling Antilag Setup:")
   ac.setSize(lc_map, 400, 200)
   ac.setVisible(lc_map, 0)
   #ac.setBackgroundOpacity(lc_map, 0.9)
   
   btn_lc_active = ac.addButton(lc_map, "OFF")
   ac.setPosition(btn_lc_active, 40, 30)
   ac.setSize(btn_lc_active, 40, 20)
   ac.setFontColor(btn_lc_active, 1, 1, 1, 0.5)
   ac.addOnClickedListener(btn_lc_active, lc_on)
   
   btn_lc2_active = ac.addButton(lc_map, "OFF")
   ac.setPosition(btn_lc2_active, 120, 30)
   ac.setSize(btn_lc2_active, 40, 20)
   ac.setFontColor(btn_lc2_active, 1, 1, 1, 0.5)
   ac.addOnClickedListener(btn_lc2_active, lc2_on)
   
   lc_info_rpm = ac.addLabel(lc_map, "Launch Control RPM: {}".format(lc_rpms))
   ac.setPosition(lc_info_rpm, 40, 60)
   ac.setFontSize(lc_info_rpm, 10)
   
   btn_lc_rpm1 = ac.addButton(lc_map, "-")
   ac.setPosition(btn_lc_rpm1, 60, 80)
   ac.setSize(btn_lc_rpm1, 20, 20)
   ac.addOnClickedListener(btn_lc_rpm1, rem_lc_rpm)

   btn_lc_rpm2 = ac.addButton(lc_map, "+")
   ac.setPosition(btn_lc_rpm2, 100, 80)
   ac.setSize(btn_lc_rpm2, 20, 20)
   ac.addOnClickedListener(btn_lc_rpm2, add_lc_rpm)
   
   lc_info_speed = ac.addLabel(lc_map, "Rolling Antilag activation speed: {}".format(lc_speed))
   ac.setPosition(lc_info_speed, 200, 60)
   ac.setFontSize(lc_info_speed, 10)
   
   btn_lc_speed1 = ac.addButton(lc_map, "-")
   ac.setPosition(btn_lc_speed1, 220, 80)
   ac.setSize(btn_lc_speed1, 20, 20)
   ac.addOnClickedListener(btn_lc_speed1, rem_lc_speed)

   btn_lc_speed2 = ac.addButton(lc_map, "+")
   ac.setPosition(btn_lc_speed2, 260, 80)
   ac.setSize(btn_lc_speed2, 20, 20)
   ac.addOnClickedListener(btn_lc_speed2, add_lc_speed)
   
   lc_info_timing = ac.addLabel(lc_map, "Timing Retard: {} deg".format(lc_timing))
   ac.setPosition(lc_info_timing, 200, 120)
   ac.setFontSize(lc_info_timing, 10)
   
   btn_lc_timing1 = ac.addButton(lc_map, "-")
   ac.setPosition(btn_lc_timing1, 220, 140)
   ac.setSize(btn_lc_timing1, 20, 20)
   ac.addOnClickedListener(btn_lc_timing1, rem_lc_timing)

   btn_lc_timing2 = ac.addButton(lc_map, "+")
   ac.setPosition(btn_lc_timing2, 260, 140)
   ac.setSize(btn_lc_timing2, 20, 20)
   ac.addOnClickedListener(btn_lc_timing2, add_lc_timing)
   
   lc_info_afr = ac.addLabel(lc_map, "AFR Enrichment: {} %".format(lc_afr))
   ac.setPosition(lc_info_afr, 40, 120)
   ac.setFontSize(lc_info_afr, 10)
   
   btn_lc_afr1 = ac.addButton(lc_map, "-")
   ac.setPosition(btn_lc_afr1, 60, 140)
   ac.setSize(btn_lc_afr1, 20, 20)
   ac.addOnClickedListener(btn_lc_afr1, rem_lc_afr)

   btn_lc_afr2 = ac.addButton(lc_map, "+")
   ac.setPosition(btn_lc_afr2, 100, 140)
   ac.setSize(btn_lc_afr2, 20, 20)
   ac.addOnClickedListener(btn_lc_afr2, add_lc_afr)
    
      
   load_boost_table()
 
   #sounds
   sound_turbo.play(-1)
   sound_bang.play(-1)
   sound_bang2.play(-1)
   sound_antilag_rev.play(-1)
   sound_turbo.set_volume(0)   
   sound_bang.set_volume(0)
   sound_bang2.set_volume(0)
   sound_antilag_rev.set_volume(0)
      
   return "Ecu_tuner"

def acUpdate(deltaT):
   global l_lapcount, throttle_perc, throttle_set, throttle_set_ign, throttle_set_rest, throttle_set_1, throttle_set_a, throttle_set_1s, throttle_set_2, throttle_set_2s, throttle_perc_1, throttle_perc_a, throttle_perc_1s, throttle_perc_2, throttle_perc_2s
   global time1, time0, time2, time3, time4, time5, time6, time7, time8, time9, time10, time11, time12, time13, time14, time15, time16, time17, time18, time19, time20, time21, time22, time23, time24, time25, time26, time27, time28, time29
   global boost_max, boost_set, boost_timer, fuelcut, throttle_switch, spring, banner, banner_img, ecu_light, mbc_logo, throttle_set_total
   global mbc_pos, mbc_factor, gas_info, boost_table_pos, boost_table_pos1, boost_set_pwm, boost_total, vacuum, afr_info1, afr_info, afr_base_table_pos, ign_info1, ign_info, ign_base_table_pos
   global afr_table_pos, boost_map_value_perc, boost_map_value_perc0, boost_map_value_perc1, boost_map_value_perc0a, boost_map_value_perc0b, switch1
   global boost_map_value_perc1a, boost_map_value_perc1b, boost_table_pos1a, boost_table_pos1_old, brake_info1, clutch_info1
   global afr_map_value_perc, afr_map_value_perc0, afr_map_value_perc1, afr_map_value_perc0a, afr_map_value_perc0b, afr_map_value_perc1a, afr_map_value_perc1b, switch2
   global afr_table_pos1a_old, afr_table_pos1, afr_table_pos1a, afr_table_pos1_old, boost_map_value_perc_old, afr_map_value_perc_old
   global smoother_sum, smoother_sum_ign, gas_info1, gas_correct, gas_cut_factor, gas_cut_factor2, key_pressed, throttle_cut, afr_table_pos1_display, ign_table_pos1_display 
   global ecu_codes_total, ecu_code_reading, ecu_code_value, ecu_reading
   global ign_table_pos, ign_map_value_perc, ign_map_value_perc0, ign_map_value_perc1, ign_map_value_perc0a, ign_map_value_perc0b, ign_map_value_perc1a, ign_map_value_perc1b, switch3
   global ign_map_value_perc, ign_map_value_perc0, ign_map_value_perc1, ign_map_value_perc0a, ign_map_value_perc0b, ign_map_value_perc1a, ign_map_value_perc1b, switch4
   global ign_table_pos1a_old, ign_table_pos1, ign_table_pos1a, ign_table_pos1_old, ign_map_value_perc_old, ign_table_pos1_diff, smoother_sum_ign_diff, ign_table_pos1_diff_forboost, smoother_sum_boost
   global shifting, gear_info_old, almost_limiter, counter_ign, counter_afr, counter_pwm, car_name, car_name1, duty_cycle, injectors, inj_factor, inj_afr, inj_size_afr, trigger1, rpms_car_factor
   global rpms, lc_btn_on, lc2_btn_on, lc_rpms, lc_speed, lc_timing, lc_afr, throttle_perc_x10, throttle_perc_x1, rolling_antilag, trigger2, trigger3, trigger4, throttle_set_ra, throttle_set_antilag, lc_boost_oscilation, speed_info
   global boost_set_antilag, boost_timer_antilag, antilag, boost_timer_springs, boost_set_springs, button1
   global sound_turbo, boost_volume, sound_bang, sound_bang2, sound_antilag_rev
   global trigger5, ext_intensity_info, ext_intensity_info2, ext_intensity_info3, ext_intensity_info4, ext_intensity_info5, smoke_intensity, flame_intensity, smoke_spread, boost_set_lua, ext_ecu_light
   
   time26 = round(time.time() * 1000)

   if (key_pressed > 0) and trigger4 == 0:
      time27 = round(time.time() * 1000)
      trigger4 = 1
   if ((time27 + 100) < time26) and (trigger4 == 1): 
      key_pressed = 0
      trigger4 = 0
      time27 = round(time.time() * 1000)



   #afr_info1 = boost_table_pos1 # len docasne
   #ac.log(str(car_name))
   speed_info = int(ac.getCarState(0, acsys.CS.SpeedKMH))
   rpms = int(ac.getCarState(0, acsys.CS.RPM))
   brake_info1 = (ac.getCarState(0, acsys.CS.Brake))
   clutch_info1 = (ac.getCarState(0, acsys.CS.Clutch))   
   boost_info = ac.getCarState(0, acsys.CS.TurboBoost)
   gear_info = ac.getCarState(0, acsys.CS.Gear)
   gas_info = round(ac.getCarState(0, acsys.CS.Gas), 4)
   gas_info1 = round(ac.getCarState(0, acsys.CS.Gas), 2)
   ign_info1 = int(ign_table_pos1_display)

   #car names
   car_name = ac.getCarName(0)   
   #ac.log(str(car_name)) 
   if (car_name != "ks_toyota_supra_mkiv_ecu_pro") and (car_name != "ferrari_f40_ecu_pro") and (car_name != "ks_nissan_skyline_r34_ecu_pro") and (car_name != "ks_audi_sport_quattro_ecu_pro"): 
      if (brake_info1 > 0) and (trigger1 == 0) and (throttle > 0.1): 
         #keyboard.press_and_release('ctrl+alt+shift+f')
         trigger1 = 1         
         #ac.log("here")
      car_name1 = 0
      ac.setVisible(appWindow, 0)
      ac.setVisible(boost_map, 0)      
      ac.setVisible(afr_map, 0)
      ac.setVisible(ign_map, 0)
      ac.setVisible(ecu_info, 0)   

   if (trigger5 == 0):
      trigger5 = 1
      if car_name == "ferrari_f40_ecu_pro" :
         rpms_car_factor = 1
         car_name1 = 1
         fuelcut = 1.95
         button1 = 7850  
      elif car_name == "ks_toyota_supra_mkiv_ecu_pro" :
         rpms_car_factor = 1.66 
         car_name1 = 2      
         fuelcut = 1.45
         button1 = 6900  
      elif car_name == "ks_nissan_skyline_r34_ecu_pro" :
         rpms_car_factor = 1
         car_name1 = 3    
         fuelcut = 1.2
         button1 = 8100  
      elif car_name == "ks_audi_sport_quattro_ecu_pro" :
         rpms_car_factor = 0.8 
         car_name1 = 4   
         fuelcut = 1.95
         button1 = 7300  
         


      
   if boost_total < -0.77:   
      afr_table_pos1_display = 22.4
   else:
      afr_table_pos1_display = afr_table_pos1 
      
   if afr_table_pos1_display < 7.1:
      afr_table_pos1_display = 7

   if int(ign_table_pos1) > 0:
      ign_table_pos1_display = ign_table_pos1
      ac.setText(ign_info, "IGN: {} BTDC".format(ign_info1))
   elif int(ign_table_pos1) < 0:
      ign_table_pos1_display = - ign_table_pos1
      ac.setText(ign_info, "IGN: {} ATDC".format(ign_info1))
   elif int(ign_table_pos1) == 0:
      ign_table_pos1_display = 0
      ac.setText(ign_info, "IGN: {} TDC".format(ign_info1))
   
   afr_info1 = round(afr_table_pos1_display, 1)

   ac.setText(inj_dc_info, "Inj DC: {}".format(duty_cycle))
   ac.setText(l_lapcount, "RPM: {}".format(rpms))   
   ac.setText(boost, "Boost: {}".format(boost_total))
   ac.setText(afr_info, "AFR: {}".format(afr_info1))    
   ac.setText(rpm_limiter_value, "set RPM: {}".format(button1))
   throttle_perc = int(throttle_perc)   
   ac.setText(throttle, "set throttle: {}".format(throttle_set_a))
   ac.setText(fuelcut_value, "set Boost: {}".format(round(fuelcut, 2)))
   ac.setText(mbc_info, "MBC: {}".format(mbc_pos)) #mbc_pos
   ac.setText(brake_info, "TPS: {}".format(gas_info))   
   ac.setText(lc_info_rpm, "Launch Control RPM: {}".format(lc_rpms))
   ac.setText(lc_info_speed, "Rolling Antilag activation speed: {}".format(lc_speed))
   ac.setText(lc_info_timing, "Timing Retard: {} deg".format(lc_timing))
   ac.setText(lc_info_afr, "AFR Enrichment: {} %".format(lc_afr))
   
   #x,y coordinates for boost_table
   ac.setPosition(btn_x, 0, 440 - (rpms / 22.5))
   ac.setPosition(btn_y, 80 + (boost_info * 250), 0)

   #x,y coordinates for afr_table
   ac.setPosition(btn_x2, 0, 440 - (rpms / 22.5))
   ac.setPosition(btn_y2, 220 + (boost_total * 175), 0)   

   #x,y coordinates for ign_table
   ac.setPosition(btn_x3, 0, 440 - (rpms / 22.5))
   ac.setPosition(btn_y3, 220 + (boost_total * 175), 0)   

   #turbo sound
   boost_volume = boost_info / 3
   if (antilag == 1) or (rolling_antilag == 1):
      sound_antilag_rev.set_volume(0.2)
      sound_turbo.set_volume(boost_volume)
      if (boost_info + 0.1) > boost_set:
         time22 = round(time.time() * 1000)
         if (time23 + (random() * (4 - boost_info) * 200)) < time22:
            sound_bang.play(1)
            sound_bang.set_volume(boost_volume * 1.2)
         if (time23 + (random() *  (10000 - rpms) / 10)) < time22:
            sound_bang2.play(1)
            sound_bang2.set_volume(boost_volume * 1.1)
            time23 = round(time.time() * 1000)
            
   else:
      sound_turbo.set_volume(boost_volume / 5)   
      sound_bang.set_volume(0)
      sound_bang2.set_volume(0)
      sound_antilag_rev.set_volume(0)
      
   #Injectors
   time18 = round(time.time() * 1000)
   if injectors == 1: #for stock
      inj_size_afr = 1
      if car_name1 == 1:
         inj_factor = 220
      if car_name1 == 2:
         #ac.log("car2")
         inj_factor = 190 #supra mk4 stock inj duty_cycle limit
      if car_name1 == 3:
         #ac.log("car3")
         inj_factor = 205 #skyline r34 stock inj duty_cycle limit
      if car_name1 == 4:
         inj_factor = 180 #quattro sport stock inj duty_cycle limit

   if injectors == 2: #for 650cc
      if car_name1 == 1:
         inj_factor = 280
         inj_size_afr = 1.273
      if car_name1 == 2:
         inj_factor = 250 #supra mk4 650cc inj duty_cycle limit
         inj_size_afr = 1.17 #supra mk4 afr factor for 650cc
      if car_name1 == 3:
         inj_factor = 265 #skyline r34 650cc inj duty_cycle limit
         inj_size_afr = 1.17 #skyline r34 afr factor for 650cc    
      if car_name1 == 4:
         inj_factor = 240 
         inj_size_afr = 1.17          


   duty_cycle = (boost_total + 0.8) * rpms / inj_factor
   duty_cycle = duty_cycle + (duty_cycle * ((12.8 - afr_info1) / 10))
   duty_cycle = int(duty_cycle)
   
   if duty_cycle > 90:
      duty_cycle = 91
   
   if (time19 + 50) < time18:  
      if duty_cycle > 90:
         ecu_codes_list[1] = 1   
      
      
      if (duty_cycle < 50) and (duty_cycle > 0) and (injectors == 2):
         inj_afr = (random() * 10 - 5 ) / duty_cycle    #injectors factor for afr..big injectors = big factor
      #ac.log(str(duty_cycle))
      time19 = round(time.time() * 1000)

      if injectors == 1:
         inj_afr = 0
      time19 = round(time.time() * 1000)      
   
   #boost_total---here
   if (gas_info > 0.25) or (rpms < 1):
      vacuum = -0.01
   if (gas_info < 0.1):
      if (rpms > 1):
         vacuum = -0.8
   if (gas_info > 0.1) and (gas_info < 0.16):
      if (rpms > 1):
         vacuum = -(9000 - rpms) / 13000
   if (gas_info > 0.15) and (gas_info < 0.25):
      if (rpms > 1):
         vacuum = -(9000 - rpms) / 16000 
  
   boost_info = round(boost_info, 3)
   if antilag + rolling_antilag == 0:
      boost_total = round(vacuum + boost_info, 3)
   elif antilag + rolling_antilag > 0:
      boost_total = round(boost_info, 3)
      
   if (brake_info1 > 0.5 and gas_info < 0.2) and (antilag == 0):
      boost_total = -0.8
   
   #shifting? && throttle < 0.25
   time16 = round(time.time() * 1000)
  
   if (time17 + 5) < time16 and shifting == 0:   
      if int(gear_info) != int(gear_info_old) or gas_info < 0.25:
         shifting = 1
         #ac.log("shifting")
  
   elif shifting == 1:
      if (time17 + 1500) < time16: #shifting timer
         shifting = 0
         #ac.log("done")
         gear_info_old = gear_info
         time17 = round(time.time() * 1000)


   #show boost, afr table actual position
   time6 = round(time.time() * 1000)
  
   if (time7 + 2) < time6: #set time for refreshing boost table

      for a in range(0, 64):
         ac.setBackgroundOpacity(ar_list[int(a)], 0)
         ac.setBackgroundOpacity(afr_list[int(a)], 0)         
         ac.setBackgroundOpacity(ign_list[int(a)], 0)
         
      if(rpms > 0):     
         boost_table_pos = (rpms / 1100)      
         boost_table_pos = int(boost_table_pos)
         boost_table_pos = (boost_table_pos * 8) + (boost_info * 4)
         ac.setBackgroundOpacity(ar_list[int(boost_table_pos)], 1)
                  
         afr_base_table_pos = (rpms / 1100) 
         afr_base_table_pos = int(afr_base_table_pos)
         afr_base_table_pos = (afr_base_table_pos * 8) + ((boost_total + 0.8) / 0.36) 
         ac.setBackgroundOpacity(afr_list[int(afr_base_table_pos)], 1)

         ign_base_table_pos = afr_base_table_pos
         ac.setBackgroundOpacity(ign_list[int(ign_base_table_pos)], 1)
        
      switch1 = 0
      switch2 = 0
      switch3 = 0
      switch4 = 0
      ar_perc.clear() 
      afr_perc.clear()
      boost_table_pos1 = 0
      afr_table_pos1 = 0
      ign_table_pos1 = 0     
      ign_table_pos1_diff = 0      

   
      for a in range(0, 64):
         if a % 8 == 0:
           
            boost_map_value_perc0 =  ((rpms / 1100 - 0.5) * 8) - a 
            boost_map_value_perc0 = 100 - (boost_map_value_perc0 * 12.5)
            afr_map_value_perc0 =  ((rpms / 1100 - 0.5) * 8) - a 
            afr_map_value_perc0 = 100 - (afr_map_value_perc0 * 12.5)
            
            if (boost_map_value_perc0 > 100):
               boost_map_value_perc0 = 200 - boost_map_value_perc0
            if (boost_map_value_perc0 < 1) or (boost_map_value_perc0 > 199):
               boost_map_value_perc0 = 0
            #ac.log(str(boost_map_value_perc0))
            if (afr_map_value_perc0 > 100):
               afr_map_value_perc0 = 200 - afr_map_value_perc0
            if (afr_map_value_perc0 < 1) or (afr_map_value_perc0 > 199):
               afr_map_value_perc0 = 0
            
            if boost_map_value_perc0 > 0 and switch1 == 0:
               boost_map_value_perc0a = boost_map_value_perc0
               switch1 = a
               #ac.log(str(boost_map_value_perc0a))
            if boost_map_value_perc0 > 0 and a > switch1 and switch1 > 0:
               boost_map_value_perc0b = boost_map_value_perc0
               switch1 = 64
               #ac.log(str(boost_map_value_perc0b))
               
            if afr_map_value_perc0 > 0 and switch2 == 0:
               afr_map_value_perc0a = afr_map_value_perc0
               switch2 = a
            if afr_map_value_perc0 > 0 and a > switch2 and switch2 > 0:
               afr_map_value_perc0b = afr_map_value_perc0
               switch2 = 64
               
         else: 
            boost_map_value_perc0 = -1
               
            if boost_map_value_perc0 == -1:
               afr_map_value_perc0 = -1

          
         #ac.log(str(boost_map_value_perc0a))         
         #ac.log(str(boost_map_value_perc0b))   

         
         
         boost_map_value_perc1 =  (boost_info / 0.28571) + (int(rpms / 1100) * 8) - a 
         boost_map_value_perc1 = 100 - (boost_map_value_perc1 * 100)         
         if (boost_map_value_perc1 > 100):
            boost_map_value_perc1 = 200 - boost_map_value_perc1
         if (boost_map_value_perc1 < 1) or (boost_map_value_perc1 > 199):
            boost_map_value_perc1 = 0
             
         
         boost_map_value_perc1a = (boost_info / 0.28571) + (int(rpms / 1100) * 8)- a + 8
         boost_map_value_perc1b = (boost_info / 0.28571) + (int(rpms / 1100) * 8)- a - 8
 
         boost_map_value_perc1a = 100 - (boost_map_value_perc1a * 100)
         boost_map_value_perc1b = 100 - (boost_map_value_perc1b * 100)

         afr_map_value_perc1 =  ((boost_total + 0.8) / 0.4) + (int(rpms / 1100) * 8) - a 
         afr_map_value_perc1 = 100 - (afr_map_value_perc1 * 100)         
         if (afr_map_value_perc1 > 100):
            afr_map_value_perc1 = 200 - afr_map_value_perc1
         if (afr_map_value_perc1 < 1) or (afr_map_value_perc1 > 199):
            afr_map_value_perc1 = 0
             
         
         afr_map_value_perc1a = ((boost_total + 0.8) / 0.4) + (int(rpms / 1100) * 8) - a + 8
         afr_map_value_perc1b = ((boost_total + 0.8) / 0.4) + (int(rpms / 1100) * 8) - a - 8
 
         afr_map_value_perc1a = 100 - (afr_map_value_perc1a * 100)
         afr_map_value_perc1b = 100 - (afr_map_value_perc1b * 100)


         if (boost_map_value_perc1a > 100):
            boost_map_value_perc1a = 200 - boost_map_value_perc1a
         if (boost_map_value_perc1a < 1) or (boost_map_value_perc1a > 199):
            boost_map_value_perc1a = 0
         if (boost_map_value_perc1b > 100):
            boost_map_value_perc1b = 200 - boost_map_value_perc1b
         if (boost_map_value_perc1b < 1) or (boost_map_value_perc1b > 199):
            boost_map_value_perc1b = 0            
         #ac.log(str(boost_map_value_perc1a))
         #ac.log(str(boost_map_value_perc1b))
        
         if (afr_map_value_perc1a > 100):
            afr_map_value_perc1a = 200 - afr_map_value_perc1a
         if (afr_map_value_perc1a < 1) or (afr_map_value_perc1a > 199):
            afr_map_value_perc1a = 0
         if (afr_map_value_perc1b > 100):
            afr_map_value_perc1b = 200 - afr_map_value_perc1b
         if (afr_map_value_perc1b < 1) or (afr_map_value_perc1b > 199):
            afr_map_value_perc1b = 0            


     
         #map function (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
              
              
         if (boost_map_value_perc0a > boost_map_value_perc0b) and (boost_map_value_perc0a * boost_map_value_perc0b > 0):
           if boost_map_value_perc1 > 0:   
              boost_map_value_perc1 = (boost_map_value_perc1 + boost_map_value_perc0a) / 4
           if boost_map_value_perc1a > 0:   
              boost_map_value_perc1a = (boost_map_value_perc1a + boost_map_value_perc0b) / 4
           boost_map_value_perc1b = 0
           #ac.log(str(boost_map_value_perc1))
           #ac.log(str(boost_map_value_perc1a))
           
         elif (boost_map_value_perc0a < boost_map_value_perc0b) and (boost_map_value_perc0a * boost_map_value_perc0b > 0):
           if boost_map_value_perc1 > 0:   
              boost_map_value_perc1 = (boost_map_value_perc1 + boost_map_value_perc0b) / 4
           if boost_map_value_perc1b > 0:   
              boost_map_value_perc1b = (boost_map_value_perc1b + boost_map_value_perc0a) / 4
           boost_map_value_perc1a = 0
           #ac.log(str(boost_map_value_perc1))
           #ac.log(str(boost_map_value_perc1b))
         

         if (afr_map_value_perc0a > afr_map_value_perc0b) and (afr_map_value_perc0a * afr_map_value_perc0b > 0):
           if afr_map_value_perc1 > 0:   
              afr_map_value_perc1 = (afr_map_value_perc1 + afr_map_value_perc0a) / 4
           if afr_map_value_perc1a > 0:   
              afr_map_value_perc1a = (afr_map_value_perc1a + afr_map_value_perc0b) / 4
           afr_map_value_perc1b = 0
           #ac.log(str(boost_map_value_perc1))
           #ac.log(str(boost_map_value_perc1a))
           
         elif (afr_map_value_perc0a < afr_map_value_perc0b) and (afr_map_value_perc0a * afr_map_value_perc0b > 0):
           if afr_map_value_perc1 > 0:   
              afr_map_value_perc1 = (afr_map_value_perc1 + afr_map_value_perc0b) / 4
           if afr_map_value_perc1b > 0:   
              afr_map_value_perc1b = (afr_map_value_perc1b + afr_map_value_perc0a) / 4
           afr_map_value_perc1a = 0
         
            
         #map function (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
         if a % 8 == 0 and boost_info == 0:
            boost_map_value_perc = boost_map_value_perc0 * 0.97
         else:
            boost_map_value_perc = boost_map_value_perc1 + boost_map_value_perc1a + boost_map_value_perc1b

         if boost_map_value_perc > 100:
            boost_map_value_perc = boost_map_value_perc_old
         else:
            boost_map_value_perc_old = boost_map_value_perc

         if a % 8 == 0 and boost_total == -0.8:
            afr_map_value_perc = afr_map_value_perc0 * 0.97
         else:
            afr_map_value_perc = afr_map_value_perc1 + afr_map_value_perc1a + afr_map_value_perc1b

         if afr_map_value_perc > 100:
            afr_map_value_perc = afr_map_value_perc_old
         else:
            afr_map_value_perc_old = afr_map_value_perc
         
 
         ar_perc.append(int(boost_map_value_perc))         
         afr_perc.append(int(afr_map_value_perc))         
         
         boost_table_pos1a = ar_perc[a]
         afr_table_pos1a = afr_perc[a]   
         
         boost_table_pos1a = boost_table_pos1a * 1.04   
         afr_table_pos1a = afr_table_pos1a * 1.04            
         ign_table_pos1a = afr_table_pos1a
         
         if rpms < 150:
            afr_table_pos1 = 22.4 #engine off
            ign_table_pos1 = 15 #engine off
         if rpms > 150 and rpms < 1500 and boost_total == -0.8:
            afr_table_pos1 = 14.7 #idle
            ign_table_pos1 = 12 #idle
            ign_table_pos1_diff = 0
         else:
            afr_table_pos1 += ( ac.getValue(afr_base_list[int(a)]) * (-(ac.getValue(afr_list[int(a)]))/100 + 1 )) * (afr_table_pos1a / 100) 
            ign_table_pos1 += ( ac.getValue(ign_base_list[int(a)]) + (ac.getValue(ign_list[int(a)])) ) * (ign_table_pos1a / 100) 
            ign_table_pos1_diff +=  (ac.getValue(ign_list[int(a)])) * (ign_table_pos1a / 100) 

         boost_table_pos1 += ac.getValue(ar_list[int(a)]) * (boost_table_pos1a / 100)   
         if boost_table_pos1 > 100:
            boost_table_pos1 = boost_table_pos1_old
         else:
            boost_table_pos1_old = boost_table_pos1
            
         boost_table_pos1 = round(boost_table_pos1, 1)
            
         afr_table_pos1 = round(afr_table_pos1, 1) 
         ign_table_pos1 = int(ign_table_pos1)        

      afr_table_pos1 = afr_table_pos1 / inj_size_afr        

      if (afr_table_pos1 > 22) or (afr_table_pos1 < 9):
         afr_table_pos1 = afr_table_pos1_old
      else:
         afr_table_pos1_old = afr_table_pos1

      if (ign_table_pos1 > 52) or (ign_table_pos1 < -40):
         ign_table_pos1 = ign_table_pos1_old
      else:
         ign_table_pos1_old = ign_table_pos1


      if (afr_table_pos1 - 3 > smoother_sum) or (afr_table_pos1 + 3 < smoother_sum):
         afr_table_pos1 = smoother_sum

      if (ign_table_pos1 - 10 > smoother_sum_ign) or (ign_table_pos1 + 10 < smoother_sum_ign):
         ign_table_pos1 = smoother_sum_ign

      #if (boost_table_pos1 - 30 > smoother_sum_boost) or (boost_table_pos1 + 30 < smoother_sum_boost):
         #boost_table_pos1 = smoother_sum_boost

      smoother_sum = (smoother_sum * 4 + afr_table_pos1) / 5  
      

 
      smoother_sum_ign = (smoother_sum_ign * 9 + ign_table_pos1) / 10 
      
      if (antilag == 1) or (rolling_antilag == 1):
         afr_table_pos1 = smoother_sum - (lc_afr / 10)
         ign_table_pos1 = smoother_sum_ign - lc_timing
      else:
        ign_table_pos1 = smoother_sum_ign
        afr_table_pos1 = smoother_sum
        
      smoother_sum_boost = (smoother_sum_boost * 2 + boost_table_pos1) / 3  
      
      boost_table_pos1 = smoother_sum_boost      

      smoother_sum_ign_diff = (smoother_sum_ign_diff * 4 + ign_table_pos1_diff) / 5  
      
      ign_table_pos1_diff = int(smoother_sum_ign_diff)
      
      if (antilag == 0) or (rolling_antilag == 0):
         afr_table_pos1 = afr_table_pos1 + (ign_table_pos1_diff * 0.1) + inj_afr #afr changing based on ignition timing and injectors size
      else:
         afr_table_pos1 = afr_table_pos1 + inj_afr

      #ac.log(str(ign_table_pos1))
      
      

         
      time7 = round(time.time() * 1000)
      
   #banner
   time24 = round(time.time() * 1000)
   if ((time25 + 50) < time24):
      banner_img += 1
      if banner_img > 80:
         banner_img = 0
      if int(banner_img) < 10:
         ac.setBackgroundTexture(banner,"apps/python/Ecu_tuner/data/banner/a_0000{}.png".format(banner_img))
      else:
         ac.setBackgroundTexture(banner,"apps/python/Ecu_tuner/data/banner/a_000{}.png".format(banner_img))
      time25 = round(time.time() * 1000)
      
   
   # ecu light
   if (ecu_light == 0):
      ac.setBackgroundTexture(ecu_logo,"apps/python/Ecu_tuner/data/ecu0.png")
   if (ecu_light == 1):
      ac.setBackgroundTexture(ecu_logo,"apps/python/Ecu_tuner/data/ecu.png")

   # mbc position
   if (mbc_pos == 0):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a0.png")
   if (mbc_pos == 1):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a1.png")
   if (mbc_pos == 2):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a2.png")
   if (mbc_pos == 3):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a3.png")
   if (mbc_pos == 4):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a4.png")
   if (mbc_pos == 5):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a5.png")
   if (mbc_pos == 6):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a6.png")
   if (mbc_pos == 7):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a7.png")
   if (mbc_pos == 8):
      ac.setBackgroundTexture(mbc_logo,"apps/python/Ecu_tuner/data/mbc/a8.png")

   #mbc factor
   mbc_factor = mbc_pos * 0.125

   # fuel cut limiter
   time4 = round(time.time() * 1000)

   if (boost_info > fuelcut) or (duty_cycle > 90):
      throttle_switch = 1
      throttle_cut = 1
      if boost_info > fuelcut:
         ecu_codes_list[0] = 1


      #ac.log("FC")

   if ((time5 + 1500) < time4) and (throttle_cut == 1) and (throttle_switch == 1): #set time for fuel cut when activated
      throttle_cut = 2
      throttle_switch = 0
      #ac.log("2")
      time5 = round(time.time() * 1000)

   #throttle cutter based on ignition
   time14 = round(time.time() * 1000)
   ign_table_pos1 = int(ign_table_pos1)
 
   if (time15 + 50) < time14: 

      if (boost_total > -0.5) and (boost_total < 0.038) and (ign_table_pos1 > 37):
         if (time15 + 100 < time14) and shifting == 0 and throttle_cut == 0 and throttle_switch == 0 and almost_limiter == 0 and rolling_antilag == 0 and antilag == 0:
            if rpms > 2000:
               ac.log("ECU error: \n")               
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(ign_table_pos1) + " ign")  
               ecu_codes_list[6] = 1
            throttle_cut = 1
            throttle_switch = 6         

      if boost_total > 0.028 and ign_table_pos1 > (36 - (boost_info * 10)):
         counter_ign += 1
         if counter_ign < 10:
            time15 = round(time.time() * 1000)
         #ac.log(str(counter_ign))
         if (time15 + 100 < time14) and shifting == 0 and throttle_cut == 0 and throttle_switch == 0 and almost_limiter == 0 and counter_ign > 9 and rolling_antilag == 0 and antilag == 0:
            if rpms > 2000:
               ac.log("ECU error: \n")               
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(ign_table_pos1) + " ign")       
               ecu_codes_list[6] = 1
            throttle_cut = 1
            throttle_switch = 6
            counter_ign = 0
      else:
         counter_ign = 0

      if ign_table_pos1_diff < -9:
         if (time15 + 100 < time14) and shifting == 0 and throttle_cut == 0 and throttle_switch == 0 and almost_limiter == 0  and rolling_antilag == 0 and antilag == 0:
            if rpms > 2000:   
               ac.log("ECU error: \n")               
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(ign_table_pos1) + " ign")             
               ecu_codes_list[5] = 1         
            throttle_cut = 1
            throttle_switch = 7      

      if throttle_switch == 6:
         if ((time15 + 300) < time14):
            throttle_cut = 2
            throttle_switch = 0
            time15 = round(time.time() * 1000)

      if throttle_switch == 7:
         if (time15 + (- ign_table_pos1_diff * 10) < time14):
            throttle_cut = 2
            throttle_switch = 0
            time15 = round(time.time() * 1000)

   #throttle cutter based on afr
   time10 = round(time.time() * 1000)
   
               
   if (time11 + 60) < time10:

      if (rpms + 500) > button1:
         almost_limiter = 1
      else:
         almost_limiter = 0

      gas_cut_factor = (10 - afr_info1) * 300
      gas_cut_factor2 = (afr_info1 - 16.5) * 100
      if (afr_info1 < 10) and (afr_info1 > 6.9) and (gas_info > 0.1) and (boost_total > -0.57):
         if ((time11 + 100) < time10) and shifting == 0 and throttle_cut == 0 and throttle_switch == 0 and almost_limiter == 0 and rolling_antilag == 0 and antilag == 0:
            #ac.log("1a")
            if rpms > 2000:
               ac.log("ECU error: \n")
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(afr_info1) + " afr")    
               ecu_codes_list[3] = 1            
            throttle_cut = 1
            throttle_switch = 3            
      if (throttle_switch == 3):
         if ((time11 + gas_cut_factor) < time10):
            #ac.log("1c1")
            throttle_cut = 2
            throttle_switch = 0            
            time11 = round(time.time() * 1000)

      if (afr_info1 < 22) and (afr_info1 > 17) and (gas_info > 0.1) and (boost_total > -0.57) and (boost_total < 0.038):
         if ((time11 + 100) < time10) and shifting == 0 and throttle_cut == 0 and throttle_switch == 0 and almost_limiter == 0 and rolling_antilag == 0 and antilag == 0:
            #ac.log("1b")
            if rpms > 2000:
               ac.log("ECU error: \n")
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(afr_info1) + " afr")               
               ecu_codes_list[2] = 1             
            throttle_cut = 1
            throttle_switch = 4     
      if (throttle_switch == 4):
         if ((time11 + gas_cut_factor2) < time10):
            #ac.log("1c2")
            throttle_cut = 2
            throttle_switch = 0            
            time11 = round(time.time() * 1000)

      if (afr_info1 > (12.9 - (boost_info / 1.2))) and (boost_total > 0.2) and (boost_total < 2.01):
         #ac.log("boost cut")
         counter_afr += 1
         if counter_afr < 10:
            time11 = round(time.time() * 1000)
         #ac.log(str(counter_afr))         
         if ((time11 + 100) < time10) and (gas_info > 0.24) and (shifting == 0) and (throttle_cut == 0) and (throttle_switch == 0) and (almost_limiter == 0) and (counter_afr > 9) and (rolling_antilag == 0) and (antilag == 0):
            if rpms > 2000:
               ac.log("ECU error: \n")               
               ac.log(str(rpms) + " rpms")
               ac.log(str(boost_total) + " bar")
               ac.log(str(afr_info1) + " afr")          
               ecu_codes_list[4] = 1
            throttle_cut = 1      
            throttle_switch = 5     
            counter_afr = 0
      else:
         counter_afr = 0

      if (throttle_switch == 5):
         if ((time11 + 500) < time10):
            #ac.log("boost cut off")
            throttle_cut = 2
            throttle_switch = 0            
            time11 = round(time.time() * 1000)

   #rolling antilag
   #lc_timing

   time20 = round(time.time() * 1000)
   


   if (time21 + 10) < time20:
      if (afr_info1 > 9.4):
         boost_set_antilag =- 0.5 - ((ign_table_pos1 - 20) / 22) - (afr_info1 - (11.5 - (boost_info * 1.33)))
      else:
         if (time21 + 50) < time20:
            lc_boost_oscilation = (9.5 - afr_info1) / 5
         if (time21 + 100) < time20:
            lc_boost_oscilation = 0
         if (time21 + 150) < time20:
            time21 = round(time.time() * 1000)
         boost_set_antilag =- 0.5 - ((ign_table_pos1 - 20) / 22) - lc_boost_oscilation
         
      boost_timer_antilag = (6000 / rpms * 100) - (rpms / 200)
      if rpms < 3600:
         boost_timer_antilag = 130

      if spring == 1:
         if boost_set_antilag > (0.518 + (0.518 * mbc_factor)):
            boost_set_antilag = (0.518 + (0.518 * mbc_factor)) 
      elif spring == 2:
         if boost_set_antilag > (0.99 + (0.99 * mbc_factor)):
            boost_set_antilag = (0.99 + (0.99 * mbc_factor)) #+ boost_set_pwm   
   #ac.log(str(boost_set_antilag))
   #ac.log(str(boost_set_springs))
         

   #ac.log(str(boost_set_antilag))        
   if lc2_btn_on == 1:
      if (speed_info == 0) and (clutch_info1 < 0.05) and (gas_info == 0):
         lc_btn_on = 1
      elif (speed_info > 0) or (clutch_info1 > 0.95):
         lc_btn_on = 0
         
   if (keyboard.is_pressed('ctrl+alt+shift+d') and ( speed_info > lc_speed)) or (antilag == 1):
      boost_set = boost_set_antilag
      boost_timer = boost_timer_antilag

   else:
      boost_set = boost_set_springs
      boost_timer = boost_timer_springs      
      
   if (trigger3 == 0):
      throttle_set_ra = int(-38 + (2 - boost_info) + gear_info)   
      trigger3 = 1
   if not keyboard.is_pressed('ctrl+alt+shift+d'):
      trigger3 = 0
      #ac.log("not pressed")
      throttle_set_ra = 0



   # rpm limiter
   time0 = round(time.time() * 1000)



   if (time1 + 50) < time0:

      if (throttle_perc < -39):
         throttle_perc = -40

      elif (throttle_perc > 19):
           throttle_perc = 20   

      if (rpms > button1):
         throttle_cut = 1
         throttle_switch = 2
         
         #ac.log("3")

      elif (rpms < button1) and (throttle_cut == 1) and (throttle_switch == 2):
         throttle_cut = 2
         throttle_switch = 0
         #ac.log("3")



      if afr_table_pos1_display > 12.8:
         
         if boost_total < -0.77:
            throttle_set = 10
            throttle_set_ign = 0
            #ac.log("correct2")
         else:
            throttle_set = int(5 / (afr_table_pos1 - 12.7))
            throttle_set_ign = ign_table_pos1_diff - 10
      
      #ac.log(str(afr_table_pos1_display))      
      if (afr_table_pos1_display < 12.8):
         throttle_set = int(5 / (12.9 - afr_table_pos1))
         throttle_set_ign = ign_table_pos1_diff - 10
         
      if (throttle_set < 1):
         throttle_set = 0

      elif (throttle_set > 9):
           throttle_set = 10         

      #power from ignition table

      if (throttle_set_ign > -1):
         throttle_set_ign = 0

      elif (throttle_set_ign < -34):
           throttle_set_ign = -35         

      if (throttle_set_rest > -1):
         throttle_set_rest = 0

      elif (throttle_set_rest < -39):
           throttle_set_rest = -40
           



      #antilag
      if lc_btn_on == 1:    
        
         if (gas_info < 0.2) or (gear_info == 1):
            antilag = 1
         elif (gas_info > 0.2) and (gear_info > 1):
            #ac.log("true")
            antilag = 0
            
         if antilag == 1:
            if lc_rpms > rpms:
               throttle_set_antilag = int(lc_rpms / 2500) + 17 - (boost_info / 2)
            else:
               throttle_set_antilag = int(lc_rpms / 1800) + 14 - (boost_info / 2)   
               
            throttle_set_ign = 0
            throttle_set = 0

         else:
            throttle_set_antilag = 0

         #tps deceleration factor in antilag
         if (brake_info1 > 0.5):
            #antilag = 0
            throttle_set_antilag = 0    

      elif lc_btn_on == 0:
         throttle_set_antilag = 0 
         antilag = 0

      throttle_set_total = throttle_set + throttle_set_ign + throttle_set_antilag + throttle_set_rest

      if throttle_set_ra < -10:
         throttle_set_ign = 0
         throttle_set = 0
         throttle_set_total = throttle_set_ra
         rolling_antilag = 1
      else:
         rolling_antilag = 0 
       


         
      if (throttle_set_total > 19):
         throttle_set_total = 20

      elif (throttle_set_total < -39):
           throttle_set_total = -40  
           
      #ac.log(str(throttle_set_total))
      throttle_set_total = int(throttle_set_total)
      
      throttle_set_a = (throttle_set_total - 10) * 2 / 100
      

      if (throttle_cut < 1) and (car_name1 > 0) and (key_pressed == 0):
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'r')

         filedata = f.readlines()
         f.close()
                
         filedata[15] = str("  throttle = ") + str(throttle_set_a) + "\n" 
  
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'w')

         f.writelines(filedata)
         f.close()
         
         key_pressed = 1
         time1 = round(time.time() * 1000)

      elif (throttle_cut == 1) and (car_name1 > 0) and (key_pressed == 0):

         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'r')
            
         filedata = f.readlines()
         f.close()
                
         filedata[15] = str("  throttle = -1") + "\n" 
  
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'w')  
            
         f.writelines(filedata)
         f.close()

         key_pressed = 1
         ecu_light = 1
         time1 = round(time.time() * 1000)

      elif (throttle_cut == 2) and (car_name1 > 0) and (key_pressed == 0):

         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'r')
            
         filedata = f.readlines()
         f.close()
                
         filedata[15] = str("  throttle = 0") + "\n" 
  
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'w')  
            
         f.writelines(filedata)
         f.close()

         key_pressed = 1
         throttle_cut = 0
         ecu_light = 0
         time1 = round(time.time() * 1000)
         
       

   
   if (gas_info < 0.26) and (antilag == 0):
      boost_set_pwm = 0
      

            
   # 0.5bar spring map
   if ((spring == 1) and (gas_info > 0.25)) or (antilag == 1):

      if rpms < (2500 / rpms_car_factor):
         boost_timer_springs = 70
         boost_set_springs = 0.038
      elif (rpms > (2500 / rpms_car_factor)) and (rpms < (4500 / rpms_car_factor)):
         if boost_info < 0.05:
            boost_timer_springs = 70
            boost_set_springs = 0.118
         elif (boost_info > 0.04) and (boost_info < (0.1 + (0.1 * mbc_factor) )):
            boost_timer_springs = 300
            boost_set_springs = (0.158 + (0.118 * mbc_factor))
         elif (boost_info > (0.1 + (0.1 * mbc_factor) )) and (boost_info < (0.2 + (0.2 * mbc_factor) )):
            boost_timer_springs = 450
            boost_set_springs = (0.318 + (0.318 * mbc_factor))
         elif (boost_info > (0.2 + (0.2 * mbc_factor) )) and (boost_info < (0.3 + (0.3 * mbc_factor) )):
            boost_timer_springs = 540      
            boost_set_springs = (0.398 + (0.398 * mbc_factor))
         elif (boost_info > (0.3 + (0.3 * mbc_factor) )) and (boost_info < (0.4 + (0.4 * mbc_factor) )):
            boost_timer_springs = 750
            boost_set_springs = (0.438 + (0.438 * mbc_factor))
         elif (boost_info > (0.4 + (0.4 * mbc_factor) )) and (boost_info < (0.52 + (0.52 * mbc_factor) )):
            boost_timer_springs = 1500
            boost_set_springs = (0.518 + (0.518 * mbc_factor))
      elif (rpms > (4500 / rpms_car_factor)) and (rpms < (6000 / rpms_car_factor)):
         if boost_info < 0.05:
            boost_timer_springs = 70
            boost_set_springs = 0.118
         elif (boost_info > 0.04) and (boost_info < (0.1 + (0.1 * mbc_factor) )):
            boost_timer_springs = 250
            boost_set_springs = (0.158 + (0.158 * mbc_factor))
         elif (boost_info > (0.1 + (0.1 * mbc_factor) )) and (boost_info < (0.2 + (0.2 * mbc_factor) )):
            boost_timer_springs = 350
            boost_set_springs = (0.318 + (0.318 * mbc_factor))
         elif (boost_info > (0.2 + (0.2 * mbc_factor) )) and (boost_info < (0.3 + (0.3 * mbc_factor) )):
            boost_timer_springs = 400      
            boost_set_springs = (0.398 + (0.398 * mbc_factor))
         elif (boost_info > (0.3 + (0.3 * mbc_factor) )) and (boost_info < (0.4 + (0.4 * mbc_factor) )):
            boost_timer_springs = 550
            boost_set_springs = (0.438 + (0.438 * mbc_factor))
         elif (boost_info > (0.4 + (0.4 * mbc_factor) )) and (boost_info < (0.52 + (0.52 * mbc_factor) )):
            boost_timer_springs = 1000
            boost_set_springs = (0.518 + (0.518 * mbc_factor))
      elif rpms > (6000 / rpms_car_factor):
         if boost_info < 0.05:
            boost_timer_springs = 70
            boost_set_springs = 0.118
         elif (boost_info > 0.04) and (boost_info < (0.1 + (0.1 * mbc_factor) )):
            boost_timer_springs = 160
            boost_set_springs = (0.238 + (0.238 * mbc_factor))
         elif (boost_info > (0.1 + (0.1 * mbc_factor) )) and (boost_info < (0.2 + (0.2 * mbc_factor) )):
            boost_timer_springs = 160
            boost_set_springs = (0.318 + (0.318 * mbc_factor))
         elif (boost_info > (0.2 + (0.2 * mbc_factor) )) and (boost_info < (0.3 + (0.3 * mbc_factor) )):
            boost_timer_springs = 160     
            boost_set_springs = (0.398 + (0.398 * mbc_factor))
         elif (boost_info > (0.3 + (0.3 * mbc_factor) )) and (boost_info < (0.4 + (0.4 * mbc_factor) )):
            boost_timer_springs = 300
            boost_set_springs = (0.478 + (0.478 * mbc_factor))
         elif (boost_info > (0.4 + (0.4 * mbc_factor) )) and (boost_info < (0.52 + (0.52 * mbc_factor) )):
            boost_timer_springs = 400
            boost_set_springs = (0.518 + (0.518 * mbc_factor))


   # 1bar spring map
   elif ((spring == 2) and (gas_info > 0.25)) or (antilag == 1):
      if rpms < (2500 / rpms_car_factor):
         boost_timer_springs = 50
         boost_set_springs = 0.038
      elif (rpms > (2500 / rpms_car_factor)) and (rpms < (4500 / rpms_car_factor)):
         if boost_info < 0.05:
            boost_timer_springs = 50
            boost_set_springs = 0.118 + boost_set_pwm
         elif (boost_info > 0.04) and (boost_info < (0.2 + (0.2 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 100
            boost_set_springs = (0.318 + (0.318 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.2 + (0.2 * mbc_factor))) and (boost_info < (0.4 + (0.4 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 150
            boost_set_springs = (0.518 + (0.518 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.4 + (0.4 * mbc_factor))) and (boost_info < (0.6 + (0.6 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 150      
            boost_set_springs = (0.718 + (0.718 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.6 + (0.6 * mbc_factor))) and (boost_info < (0.8 + (0.8 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 200
            boost_set_springs = (0.918 + (0.918 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.8 + (0.8 * mbc_factor))+ boost_set_pwm):
            boost_timer_springs = 600
            boost_set_springs = (0.99 + (0.99 * mbc_factor)) + boost_set_pwm
      elif (rpms > (4500 / rpms_car_factor)) and (rpms < (6000 / rpms_car_factor)):
         if boost_info < 0.05:
            boost_timer_springs = 50
            boost_set_springs = 0.118 + boost_set_pwm
         elif (boost_info > 0.04) and (boost_info < (0.2 + (0.2 * mbc_factor))):
            boost_timer_springs = 50
            boost_set_springs = (0.318 + (0.318 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.2 + (0.2 * mbc_factor))) and (boost_info < (0.4 + (0.4 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 100
            boost_set_springs = (0.518 + (0.518 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.4 + (0.4 * mbc_factor))) and (boost_info < (0.6 + (0.6 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 100      
            boost_set_springs = (0.718 + (0.718 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.6 + (0.6 * mbc_factor))) and (boost_info < (0.8 + (0.8 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 150
            boost_set_springs = (0.918 + (0.918 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.8 + (0.8 * mbc_factor)) + boost_set_pwm):
            boost_timer_springs = 400
            boost_set_springs = (0.99 + (0.99 * mbc_factor)) + boost_set_pwm
      elif rpms > (6000 / rpms_car_factor):
         if boost_info < 0.05:
            boost_timer_springs = 50
            boost_set_springs = 0.118 + boost_set_pwm
         elif (boost_info > 0.04) and (boost_info < (0.2 + (0.2 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 100
            boost_set_springs = (0.318 + (0.318 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.2 + (0.2 * mbc_factor))) and (boost_info < (0.4 + (0.4 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 150
            boost_set_springs = (0.518 + (0.518 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.4 + (0.4 * mbc_factor))) and (boost_info < (0.6 + (0.6 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 150      
            boost_set_springs = (0.718 + (0.718 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.6 + (0.6 * mbc_factor))) and (boost_info < (0.8 + (0.8 * mbc_factor)+ boost_set_pwm)):
            boost_timer_springs = 200
            boost_set_springs = (0.918 + (0.918 * mbc_factor)) + boost_set_pwm
         elif (boost_info > (0.8 + (0.8 * mbc_factor)) + boost_set_pwm):
            boost_timer_springs = 400
            boost_set_springs = (0.99 + (0.99 * mbc_factor)) + boost_set_pwm

        

   #pwm boost solenoid

   if (mbc_pos == 0) and (rpms > (2000 / rpms_car_factor)) and (antilag == 0):
      #if(boost_info > 1):
        # boost_set = 0.99
      time8 = round(time.time() * 1000)   

      if (boost_table_pos1 < 51):
         #ac.log("working")
         if (time9 + 300) < time8:
            boost_set_pwm = boost_set_pwm + ((75 - boost_table_pos1) / 1000)
            time9 = round(time.time() * 1000)

      elif (boost_table_pos1 > 50) and (boost_table_pos1 < 80):
         #ac.log("working")
         if (time9 + 300) < time8:
            boost_set_pwm = boost_set_pwm + ((80 - boost_table_pos1) / 200)
            boost_timer_springs = boost_timer_springs + (60 /gear_info)
            time9 = round(time.time() * 1000)

      elif (boost_table_pos1 > 79):
         #ac.log("working")
         if (time9 + 300) < time8:
            if (boost_set + boost_set_pwm) < 0.039:
               boost_set_pwm = boost_set_pwm
            else: boost_set_pwm = boost_set_pwm - ((boost_table_pos1 - 80) / 150)
            time9 = round(time.time() * 1000)


      if (boost_set_pwm > 1):
         boost_set_pwm = 1
      if (boost_set_pwm < 0.039):
         boost_set_pwm = 0.038         

      #ac.log(str(boost_set))
      #boost_set = boost_set + boost_set_pwm
      #boost_timer = 70
      #ac.log(str(boost_set_pwm))
   else:
      boost_set_pwm = 0.038
      

      
   #spring boost limiter
#   time2 = round(time.time() * 1000)

   #boost by ignition
   if ign_table_pos1_diff_forboost > 10: 
      ign_table_pos1_diff_forboost = 10
   elif ign_table_pos1_diff_forboost < -5:
      ign_table_pos1_diff_forboost = -5
      
   boost_timer = boost_timer + (boost_timer * ign_table_pos1_diff_forboost / 10)
 
   #boost by mbc or pwm 
   if mbc_pos == 0:
      boost_timer = boost_timer / 2.2
   else:
      boost_timer = boost_timer   
   
   #boost by gear
   if (boost_total < 1.75) and (car_name1 > 0) and (rolling_antilag == 0) and (antilag == 0):
      if (spring == 1) and (gear_info > 1):
         if (gear_info == 2):
            boost_timer = boost_timer / (gear_info + 0.5)
         elif (gear_info == 3):
            boost_timer = boost_timer / (gear_info / 2 - 0.5)
         elif (gear_info > 3) and (gear_info < 6):
            boost_timer = boost_timer / (gear_info / 4)
         elif (gear_info == 6):
            boost_timer = boost_timer / (gear_info / 7)

      elif (spring == 2) and (gear_info > 1):
         if (gear_info == 2):
            boost_timer = boost_timer / (gear_info + 3)
         elif (gear_info == 3):
            boost_timer = boost_timer * (gear_info / 2)
         elif (gear_info > 3) and (gear_info < 6):
            boost_timer = boost_timer * (gear_info / 2)
         elif (gear_info == 6):
            boost_timer = boost_timer / (gear_info / 6)

   else:
      boost_timer = boost_timer * 1.9
      
   #boost by car
   if (car_name1 == 2) and (rolling_antilag == 0) and (antilag == 0): 
      if (rpms < 3500):
         boost_timer = boost_timer / 5
      if (rpms < 4000) and (boost_set > 0.75): #small turbo limit
         boost_set = 0.75
         


   #boost by gas(tps)
   if (gas_info > 0.25) and (gas_info < 0.51) and (gear_info > 1) and (rolling_antilag == 0) and (antilag == 0):
      boost_set = boost_set * ((gas_info / 0.9) + (gear_info / 20)) #boost % based on gas pedal.. on 0,2=0%, on 0,6= 100%

   if (boost_timer < 60):
      boost_timer = 60

   if (boost_set > 2):
      boost_set = 2

   #boost deceleration factor
   if (gas_info < 0.05) and (lc_btn_on == 0):
      boost_timer = 70
      boost_set = 0.038

   #boost deceleration factor in antilag - not working yet
   elif (gas_info < 0.05) and (lc_btn_on == 1):
      boost_set = 0.5

   
   if (boost_set < 0.038):
      boost_set = 0.038   
      
  
      
   #reading ecu codes
   if ecu_reading == 1:
      time12 = round(time.time() * 1000)
      ecu_codes_total = 0
      for a in range(0, 7):
         ecu_codes_total += ecu_codes_list[a]
      if ecu_codes_total == 0: #no error
         ecu_code_reading = 0
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0
            time13 = round(time.time() * 1000) 
         

   #ecu_code_value = ecu_codes_list[0]
   #ac.log(str(ecu_code_reading))   
      if ecu_codes_list[0] == 1 and ecu_code_reading == 0: #code 11(fuel cut)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 0    
         if (time13 + 3000) < time12:
            ecu_light = 1  
         if (time13 + 3500) < time12:
            ecu_light = 0
         if (time13 + 6000) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 1
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[0] < 1 and ecu_codes_total > 0 and ecu_code_reading == 0:
         ecu_code_reading = 1
         time13 = round(time.time() * 1000) 
         
      if ecu_codes_list[1] == 1 and ecu_code_reading == 1: #code 12(Injectors Duty Cycle over 90%)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 0    
         if (time13 + 3000) < time12:
            ecu_light = 1  
         if (time13 + 3500) < time12:
            ecu_light = 0
         if (time13 + 4000) < time12:
            ecu_light = 1  
         if (time13 + 4500) < time12:
            ecu_light = 0
         if (time13 + 7000) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 2         
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[1] < 1 and ecu_codes_total > 0 and ecu_code_reading == 1:
         ecu_code_reading = 2
         time13 = round(time.time() * 1000) 
      
      if ecu_codes_list[2] == 1 and ecu_code_reading == 2: #code 14(afr too lean)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 0    
         if (time13 + 3000) < time12:
            ecu_light = 1  
         if (time13 + 3500) < time12:
            ecu_light = 0
         if (time13 + 4000) < time12:
            ecu_light = 1  
         if (time13 + 4500) < time12:
            ecu_light = 0
         if (time13 + 5000) < time12:
            ecu_light = 1
         if (time13 + 5500) < time12:
            ecu_light = 0  
         if (time13 + 6000) < time12:
            ecu_light = 1         
         if (time13 + 6500) < time12:
            ecu_light = 0         
         if (time13 + 7000) < time12:
            ecu_light = 0
         if (time13 + 9500) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 3         
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[2] < 1 and ecu_codes_total > 0 and ecu_code_reading == 2:
         ecu_code_reading = 3
         time13 = round(time.time() * 1000) 
     
      if ecu_codes_list[3] == 1 and ecu_code_reading == 3: #code 15(afr too rich)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 0    
         if (time13 + 3000) < time12:
            ecu_light = 1  
         if (time13 + 3500) < time12:
            ecu_light = 0
         if (time13 + 4000) < time12:
            ecu_light = 1  
         if (time13 + 4500) < time12:
            ecu_light = 0
         if (time13 + 5000) < time12:
            ecu_light = 1
         if (time13 + 5500) < time12:
            ecu_light = 0  
         if (time13 + 6000) < time12:
            ecu_light = 1         
         if (time13 + 6500) < time12:
            ecu_light = 0  
         if (time13 + 7000) < time12:
            ecu_light = 1         
         if (time13 + 7500) < time12:
            ecu_light = 0         
         if (time13 + 8000) < time12:
            ecu_light = 0
         if (time13 + 10500) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 4         
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[3] < 1 and ecu_codes_total > 0 and ecu_code_reading == 3:
         ecu_code_reading = 4
         time13 = round(time.time() * 1000) 

      if ecu_codes_list[4] == 1 and ecu_code_reading == 4: #code 21(afr too lean in boost)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 1500) < time12:
            ecu_light = 1
         if (time13 + 2000) < time12:
            ecu_light = 0
         if (time13 + 3500) < time12:
            ecu_light = 0    
         if (time13 + 4000) < time12:
            ecu_light = 1  
         if (time13 + 4500) < time12:
            ecu_light = 0
         if (time13 + 7000) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 5
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[4] < 1 and ecu_codes_total > 0 and ecu_code_reading == 4:
         ecu_code_reading = 5
         time13 = round(time.time() * 1000) 

      if ecu_codes_list[5] == 1 and ecu_code_reading == 5: #code 34(ignition retarded)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 1500) < time12:
            ecu_light = 1
         if (time13 + 2000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 1
         if (time13 + 3000) < time12:
            ecu_light = 0                   
         if (time13 + 4500) < time12:
            ecu_light = 0    
         if (time13 + 5000) < time12:
            ecu_light = 1  
         if (time13 + 5500) < time12:
            ecu_light = 0
         if (time13 + 6000) < time12:
            ecu_light = 1  
         if (time13 + 6500) < time12:
            ecu_light = 0
         if (time13 + 7000) < time12:
            ecu_light = 1
         if (time13 + 7500) < time12:
            ecu_light = 0  
         if (time13 + 8000) < time12:
            ecu_light = 1         
         if (time13 + 8500) < time12:
            ecu_light = 0         
         if (time13 + 9000) < time12:
            ecu_light = 0
         if (time13 + 11500) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 6         
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[5] < 1 and ecu_codes_total > 0 and ecu_code_reading == 5:
         ecu_code_reading = 6
         time13 = round(time.time() * 1000) 

      if ecu_codes_list[6] == 1 and ecu_code_reading == 6: #code 35(ignition advanced)
         #ac.log("true")
         if (time13 + 500) < time12:
            ecu_light = 1
         if (time13 + 1000) < time12:
            ecu_light = 0       
         if (time13 + 1500) < time12:
            ecu_light = 1
         if (time13 + 2000) < time12:
            ecu_light = 0       
         if (time13 + 2500) < time12:
            ecu_light = 1
         if (time13 + 3000) < time12:
            ecu_light = 0                   
         if (time13 + 4500) < time12:
            ecu_light = 0    
         if (time13 + 5000) < time12:
            ecu_light = 1  
         if (time13 + 5500) < time12:
            ecu_light = 0
         if (time13 + 6000) < time12:
            ecu_light = 1  
         if (time13 + 6500) < time12:
            ecu_light = 0
         if (time13 + 7000) < time12:
            ecu_light = 1
         if (time13 + 7500) < time12:
            ecu_light = 0  
         if (time13 + 8000) < time12:
            ecu_light = 1         
         if (time13 + 8500) < time12:
            ecu_light = 0         
         if (time13 + 9000) < time12:
            ecu_light = 1         
         if (time13 + 9500) < time12:
            ecu_light = 0         
         if (time13 + 10000) < time12:
            ecu_light = 0
         if (time13 + 12500) < time12: # 2,5sec pause between codes
            ecu_light = 0
            ecu_code_reading = 7         
            time13 = round(time.time() * 1000) 
         
      elif ecu_codes_list[6] < 1 and ecu_codes_total > 0 and ecu_code_reading == 6:
         ecu_code_reading = 7
         time13 = round(time.time() * 1000) 

      if ecu_code_reading == 7 and ecu_codes_total > 0: #4,5sec pause and reading all codes again
         if (time13 + 4500) < time12:   
            ecu_code_reading = 0
            time13 = round(time.time() * 1000)   

   elif ecu_reading == 2:  
      ecu_light = 0
      ecu_reading = 0      
      
   #exhaust smoke&flame settings
   time28 = round(time.time() * 1000)
   if ((time29 + 200) < time28):
      smoke_intensity = (14 - afr_info1) / 10 + ((boost_total + 0.8) / 10) 
      if (smoke_intensity < 0):
         smoke_intensity = 0

       
      smoke_spread = speed_info / 10 + 0.25

      flame_intensity = (10 - ign_table_pos1)
      if (flame_intensity < 0):
         flame_intensity = (13 - afr_info1)
      #ac.log(str(flame_intensity))
      if (ecu_light == 1):
         ext_ecu_light = "(| 0=1 | 1=1 |)"
         if (car_name1 == 1) or (car_name1 > 2):
            ext_ecu_light = "0.08"
      else:
         ext_ecu_light = "(| 0=0 | 1=0 |)"
         if (car_name1 == 1) or (car_name1 > 2):
            ext_ecu_light = "0"
      
      ext_intensity_info = "INTENSITY = " + str(smoke_intensity)
      ext_intensity_info2 = "SPREAD = " + str(smoke_spread)      
      ext_intensity_info3 = "DISCHARGE_INTENSITY = " + str(flame_intensity)
      ext_intensity_info4 = "LIMITER INTENSITY = " + str(flame_intensity)
      ext_intensity_info5 = "INPUT_LUT = " + str(ext_ecu_light)      
      
      #ac.log(str(ext_intensity_info5))
      
      if (car_name1 == 1):
         ext_intensity_info5 = "RANGE = " + str(ext_ecu_light)
         f = open('content/cars/ferrari_f40_ecu_pro/extension/ext_config.ini', 'r')
      elif (car_name1 == 2):
         f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/extension/ext_config.ini', 'r')
      elif (car_name1 == 3):
         ext_intensity_info5 = "RANGE = " + str(ext_ecu_light)
         f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/extension/ext_config.ini', 'r')
      elif (car_name1 == 4):
         ext_intensity_info5 = "RANGE = " + str(ext_ecu_light)
         f = open('content/cars/ks_audi_sport_quattro_ecu_pro/extension/ext_config.ini', 'r')

      filedata = f.readlines()
      f.close()
      
      filedata[46] = str(ext_intensity_info2) + "\n"                 
      filedata[49] = str(ext_intensity_info) + "\n" 
      filedata[86] = str(ext_intensity_info3) + "\n" 
      filedata[100] = str(ext_intensity_info4) + "\n" 
      
      if (car_name1 == 1):
         filedata[35] = str(ext_intensity_info5) + "\n"
         f = open('content/cars/ferrari_f40_ecu_pro/extension/ext_config.ini', 'w')
      elif (car_name1 == 2):
         filedata[2] = str(ext_intensity_info5) + "\n"
         f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/extension/ext_config.ini', 'w')
      elif (car_name1 == 3):
         filedata[25] = str(ext_intensity_info5) + "\n"
         f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/extension/ext_config.ini', 'w')
      elif (car_name1 == 4): #here
         filedata[25] = str(ext_intensity_info5) + "\n"
         f = open('content/cars/ks_audi_sport_quattro_ecu_pro/extension/ext_config.ini', 'w')
            
      f.writelines(filedata)
      f.close()      

      key_pressed = 2
      #ac.log(str(filedata)) 
      time29 = round(time.time() * 1000)      

   #ac.log(str(ecu_codes_total))         
 
   #boost timers
   ac.setText(boost_limiter_value, "set boost: {}".format(boost_set))  

   time2 = round(time.time() * 1000)   
   if ((time3 + boost_timer) < time2) and (key_pressed != 2):
      boost_set_lua = (boost_set * 29 + 202) / 10000        

      if (car_name1 > 0):
         #keyboard.press_and_release('ctrl+alt+shift+j')
         
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'r')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'r')
            
         filedata = f.readlines()
         f.close()
                
         filedata[16] = str("  brake = ") + str(boost_set_lua) + "\n" 
  
         if (car_name1 == 1):
            f = open('content/cars/ferrari_f40_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 2):
            f = open('content/cars/ks_toyota_supra_mkiv_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 3):
            f = open('content/cars/ks_nissan_skyline_r34_ecu_pro/data/script.lua', 'w')
         elif (car_name1 == 4):
            f = open('content/cars/ks_audi_sport_quattro_ecu_pro/data/script.lua', 'w')
            
         f.writelines(filedata)
         f.close()         
         
         key_pressed = 1
         time3 = round(time.time() * 1000)
         
         
def addRPM(*args):
   global button1, car_name1
   button1 += 100
   if (car_name1 == 1) and (button1 > 7850):
      button1 = 7850
   if (car_name1 == 2) and (button1 > 6800):
      button1 = 6900
   if (car_name1 == 3) and (button1 > 8100):
      button1 = 8100
   if (car_name1 == 4) and (button1 > 7300):
      button1 = 7300
       
def remRPM(*args):
   global button1
   button1 -= 100
   if button1 < 1200:
      button1 = 1200
       
def addBoost(*args):
   global boost_set, spring
   spring = 2
   ac.setBackgroundOpacity(btnCarCommon4, 1)
   ac.setBackgroundOpacity(btnCarCommon3, 0)

def remBoost(*args):
   global boost_set, spring
   spring = 1
   ac.setBackgroundOpacity(btnCarCommon4, 0)
   ac.setBackgroundOpacity(btnCarCommon3, 1)

def inj1(*args):
   global injectors
   injectors = 1
   ac.setBackgroundOpacity(btnCarCommon5, 1)
   ac.setBackgroundOpacity(btnCarCommon6, 0)

def inj2(*args):
   global injectors
   injectors = 2
   ac.setBackgroundOpacity(btnCarCommon5, 0)
   ac.setBackgroundOpacity(btnCarCommon6, 1)

def add_fuelcut(*args):
    global fuelcut, car_name1
    fuelcut += 0.05
    if car_name1 == 1:
       if fuelcut > 1.90:
          fuelcut = 1.95
    if car_name1 == 2:
       if fuelcut > 1.4:
          fuelcut = 1.45
    if car_name1 == 3:
       if fuelcut > 1.15:
          fuelcut = 1.2
    if car_name1 == 4:
       if fuelcut > 1.9:
          fuelcut = 1.95

def rem_fuelcut(*args):
    global fuelcut
    fuelcut -= 0.05
    if fuelcut < 0.1:
       fuelcut = 0.1

def add_mbcvalue(*args):
    global mbc_pos, spring
    mbc_pos += 1

    if (mbc_pos > 8) and (spring == 1):
      mbc_pos = 0
    elif (mbc_pos > 5) and (spring == 2):
      mbc_pos = 0
      
def reading_ecu_codes(*args):
    global ecu_reading
    if ecu_reading == 1:
       ecu_reading = 2
       ac.setBackgroundOpacity(btn_ecu_codes, 0)
    else:
       ecu_reading = 1
       ac.setBackgroundOpacity(btn_ecu_codes, 1)
       
def clearing_ecu_codes(*args):   
   global a 
   for a in range (0, 7):   
      ecu_codes_list[a] = 0

def ecu_codes_info(*args):
   global ecu_info_visible
   if(ecu_info_visible == 1):
      ac.setVisible(ecu_info, 1)
      ecu_info_visible = 0
      ac.setBackgroundOpacity(ecu_info, 0.1)
   elif(ecu_info_visible == 0):
      ac.setVisible(ecu_info, 0)   
      ecu_info_visible = 1
      
def lc_on(*args):
    global lc_btn_on
    if lc_btn_on == 0:
       ac.setText(btn_lc_active, "ON")
       ac.setFontColor(btn_lc_active, 0, 1, 0, 1)
       lc_btn_on = 1
    else:
       ac.setText(btn_lc_active, "OFF")
       ac.setFontColor(btn_lc_active, 1, 1, 1, 0.5)
       lc_btn_on = 0

def lc2_on(*args):
    global lc2_btn_on
    if lc2_btn_on == 0:
       ac.setText(btn_lc2_active, "ON")
       ac.setFontColor(btn_lc2_active, 0, 1, 0, 1)
       lc2_btn_on = 1
    else:
       ac.setText(btn_lc2_active, "OFF")
       ac.setFontColor(btn_lc2_active, 1, 1, 1, 0.5)
       lc2_btn_on = 0

def add_lc_rpm(*args):
   global lc_rpms
   lc_rpms += 100
   if lc_rpms > 5900:
      lc_rpms = 6000

def rem_lc_rpm(*args):
   global lc_rpms
   lc_rpms -= 100
   if lc_rpms < 3700:
      lc_rpms = 3600
      
def add_lc_speed(*args):
   global lc_speed
   lc_speed += 5
   if lc_speed > 395:
      lc_speed = 400

def rem_lc_speed(*args):
   global lc_speed
   lc_speed -= 5
   if lc_speed < 20:
      lc_speed = 15
      
def add_lc_timing(*args):
   global lc_timing
   lc_timing += 1
   if lc_timing > 49:
      lc_timing = 50

def rem_lc_timing(*args):
   global lc_timing
   lc_timing -= 1
   if lc_timing < 21:
      lc_timing = 20
      
def add_lc_afr(*args):
   global lc_afr
   lc_afr += 1
   if lc_afr > 49:
      lc_afr = 50

def rem_lc_afr(*args):
   global lc_afr
   lc_afr -= 1
   if lc_afr < 1:
      lc_afr = 0
       
def boost_table(*args):
   global boost_map_visible
   if(boost_map_visible == 1):
      ac.setVisible(boost_map, 1)
      boost_map_visible = 0
      ac.setBackgroundOpacity(btn_boost_map, 0.9)
      ac.setBackgroundOpacity(boost_map, 0.9)
   elif(boost_map_visible == 0):
      ac.setVisible(boost_map, 0)   
      boost_map_visible = 1
      ac.setBackgroundOpacity(btn_boost_map, 0)

def afr_table(*args):
   global afr_map_visible, btn_afr_map
   if(afr_map_visible == 1):
      ac.setVisible(afr_map, 1)
      afr_map_visible = 0
      ac.setBackgroundOpacity(btn_afr_map, 0.9)
      ac.setBackgroundOpacity(afr_map, 0.9)
   elif(afr_map_visible == 0):
      ac.setVisible(afr_map, 0)   
      afr_map_visible = 1
      ac.setBackgroundOpacity(btn_afr_map, 0)
      
def ign_table(*args):
   global ign_map_visible, btn_ign_map
   if(ign_map_visible == 1):
      ac.setVisible(ign_map, 1)
      ign_map_visible = 0
      ac.setBackgroundOpacity(btn_ign_map, 0.9)
      ac.setBackgroundOpacity(ign_map, 0.9)
   elif(ign_map_visible == 0):
      ac.setVisible(ign_map, 0)   
      ign_map_visible = 1
      ac.setBackgroundOpacity(btn_ign_map, 0)    

def lc_table(*args):
   global lc_map_visible, btn_lc
   if(lc_map_visible == 1):
      ac.setVisible(lc_map, 1)
      lc_map_visible = 0
      ac.setBackgroundOpacity(btn_lc, 0.9)
      ac.setBackgroundOpacity(lc_map, 0.5)
   elif(lc_map_visible == 0):
      ac.setVisible(lc_map, 0)   
      lc_map_visible = 1
      ac.setBackgroundOpacity(btn_lc, 0)        

def save_boost_table(*args):
   global i, x, y, z, v, u, w, boost_map_value, afr_map_value, afr_base_value, boost_map_value_perc, ign_map_value, ign_base_value, car_name1
   ar.clear()    
   afr.clear()
   afr_base.clear()
   ign.clear()
   ign_base.clear()
   for i in range (0, 64) :
      x = ac.getValue(ar_list[i])
      v = ac.getValue(afr_perc[i])
      y = ac.getValue(afr_list[i])
      z = ac.getValue(afr_base_list[i])      
      u = ac.getValue(ign_list[i])
      w = ac.getValue(ign_base_list[i])
      ar.append(x)
      #ar_perc.append(v)
      afr.append(y)
      afr_base.append(z)
      ign.append(u)
      ign_base.append(w)
   #ac.log(ar)

   profile = {} 
   profile["afr_map_value"] = afr
   profile["ign_map_value"] = ign
   profile["boost_map_value"] = ar
   profile["afr_base_value"] = afr_base
   profile["ign_base_value"] = ign_base   
   profile["boost_map_value_perc"] = afr_perc

   json_object = json.dumps(profile)
 
   # Writing to f40.json
   if car_name1 == 2:
      with open("apps/python/Ecu_tuner/data/maps/supra_mk4.json", "w") as outfile:
         outfile.write(json_object)
   elif car_name1 < 2:
      with open("apps/python/Ecu_tuner/data/maps/f40.json", "w") as outfile:
         outfile.write(json_object)   
   elif car_name1 == 3:
      with open("apps/python/Ecu_tuner/data/maps/r34.json", "w") as outfile:
         outfile.write(json_object) 
   elif car_name1 == 4:
      with open("apps/python/Ecu_tuner/data/maps/quattro.json", "w") as outfile:
         outfile.write(json_object) 

def load_boost_table(*args):
   global i, boost_map_value, afr_map_value, afr_base_value, ign_map_value, ign_base_value, car_name1
   if car_name1 == 2:
      with open('apps/python/Ecu_tuner/data/maps/supra_mk4.json', 'r') as openfile:
         json_object = json.load(openfile)
        
      
         for i in range (0, 64) :
            ac.setValue(ar_list[i], json_object["boost_map_value"][i])           
            ac.setValue(afr_list[i], json_object["afr_map_value"][i])
            ac.setValue(afr_base_list[i], json_object["afr_base_value"][i])
            ac.setValue(ign_list[i], json_object["ign_map_value"][i])
            ac.setValue(ign_base_list[i], json_object["ign_base_value"][i])

   if car_name1 < 2:
      with open('apps/python/Ecu_tuner/data/maps/f40.json', 'r') as openfile:
         json_object = json.load(openfile)
        
      
         for i in range (0, 64) :
            ac.setValue(ar_list[i], json_object["boost_map_value"][i])           
            ac.setValue(afr_list[i], json_object["afr_map_value"][i])
            ac.setValue(afr_base_list[i], json_object["afr_base_value"][i])
            ac.setValue(ign_list[i], json_object["ign_map_value"][i])
            ac.setValue(ign_base_list[i], json_object["ign_base_value"][i])         
   
   if car_name1 == 3:
      with open('apps/python/Ecu_tuner/data/maps/r34.json', 'r') as openfile:
         json_object = json.load(openfile)
        
      
         for i in range (0, 64) :
            ac.setValue(ar_list[i], json_object["boost_map_value"][i])           
            ac.setValue(afr_list[i], json_object["afr_map_value"][i])
            ac.setValue(afr_base_list[i], json_object["afr_base_value"][i])
            ac.setValue(ign_list[i], json_object["ign_map_value"][i])
            ac.setValue(ign_base_list[i], json_object["ign_base_value"][i])
            
   if car_name1 == 4:
      with open('apps/python/Ecu_tuner/data/maps/quattro.json', 'r') as openfile:
         json_object = json.load(openfile)
        
      
         for i in range (0, 64) :
            ac.setValue(ar_list[i], json_object["boost_map_value"][i])           
            ac.setValue(afr_list[i], json_object["afr_map_value"][i])
            ac.setValue(afr_base_list[i], json_object["afr_base_value"][i])
            ac.setValue(ign_list[i], json_object["ign_map_value"][i])
            ac.setValue(ign_base_list[i], json_object["ign_base_value"][i])  